package com.springboot.kotlin.controller

import org.slf4j.LoggerFactory
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.PathVariable
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RequestMethod
import org.springframework.web.bind.annotation.RestController
import java.util.*

@RestController
@RequestMapping("/api")
class HelloWorldController {

    private val log = LoggerFactory.getLogger(this.javaClass.name);

    // http://localhost:6001/api/index
    @RequestMapping(value = ["/index"], method = [RequestMethod.GET])
    fun getHelloWorld(): ResponseEntity<String> =
        ResponseEntity.ok("Welcome to spring boot and kotlin!")

    // http://localhost:6001/api/welcome/daniel
    @RequestMapping(value = ["/welcome/{name}"], method = [RequestMethod.GET])
    fun getUser(@PathVariable("name") name: String): ResponseEntity<HelloResponse> =
        ResponseEntity.ok(HelloResponse(UUID.randomUUID(), message = "Hello $name"))
}

data class HelloResponse(
    val id: UUID,
    val message: String
)
